diff --git a/etc/yum.bash b/etc/yum.bash
index f1e06e8..713a72f 100644
--- a/etc/yum.bash
+++ b/etc/yum.bash
@@ -1,53 +1,27 @@
 # bash completion for yum
 
-# arguments:
-#   1 = argument to "yum list" (all, available, updates etc)
-#   2 = current word to be completed
-_yum_list()
+_yum_helper()
 {
-    # Fail fast for things that look like paths.
-    [[ $2 == */* || $2 == [.~]* ]] && return
-
-    if [ "$1" = all ] ; then
-        # Try to strip in between headings like "Available Packages" - would
-        # be nice if e.g. -d 0 did that for us.  This will obviously only work
-        # for English :P
-        COMPREPLY+=( $( ${yum:-yum} -d 0 -C list $1 "$2*" 2>/dev/null | \
-            sed -ne '/^Available /d' -e '/^Installed /d' -e '/^Updated /d' \
-            -e 's/[[:space:]].*//p' ) )
-    else
-        # Drop first line (e.g. "Updated Packages") - would be nice if e.g.
-        # -d 0 did that for us.
-        COMPREPLY+=( $( ${yum:-yum} -d 0 -C list $1 "$2*" 2>/dev/null | \
-            sed -ne 1d -e 's/[[:space:]].*//p' ) )
+    local IFS=$'\n'
+    if [[ -n "$YUM_CACHEDIR" && "$1 $2" == "list available" ]]; then
+        for db in $(find "$YUM_CACHEDIR" -name primary_db.sqlite); do
+            COMPREPLY+=( $( sqlite3 "$db" \
+                "SELECT name||'.'||arch FROM packages WHERE name LIKE '$3%'"
+            ) )
+        done
+        return
     fi
+    COMPREPLY+=( $(
+        /usr/share/yum-cli/completion-helper.py -d 0 -C "$@" 2>/dev/null ) )
 }
 
-# arguments:
-#   1 = argument to "yum repolist" (enabled, disabled etc)
-#   2 = current word to be completed
-_yum_repolist()
-{
-    # TODO: add -d 0 when http://yum.baseurl.org/ticket/29 is fixed
-    #       (for now --noplugins is used to get rid of "Loaded plugins: ...")
-    # Drop first ("repo id      repo name") and last ("repolist: ...") rows -
-    # would be nice if e.g. -d 0 did that for us.
-    COMPREPLY+=(
-        $( compgen -W "$( ${yum:-yum} --noplugins -C repolist $1 2>/dev/null | \
-            sed -ne '/^repo\s\{1,\}id/d' -e '/^repolist:/d' \
-            -e 's/[[:space:]].*//p' )" -- "$2" ) )
-}
-
-# arguments:
-#   1 = argument to "yum grouplist" (usually empty (""), or hidden)
-#   2 = current word to be completed
-_yum_grouplist()
+_yum_list()
 {
-    local IFS=$'\n'
-    # TODO: add -d 0 when http://yum.baseurl.org/ticket/29 is fixed
-    COMPREPLY=( $( compgen -W "$( ${yum:-yum} -C grouplist $1 "$2*" \
-        2>/dev/null | sed -ne 's/^[[:space:]]\{1,\}\(.\{1,\}\)/\1/p' )" \
-        -- "$2" ) )
+    # Fail fast for things that look like paths or options.
+    [[ $2 == */* || $2 == [.~-]* ]] && return
+    # Listing all available packages takes way too long
+    [[ $1 != "installed" && ${#2} -lt 1 ]] && return
+    _yum_helper list "$@"
 }
 
 # arguments:
@@ -56,7 +30,7 @@ _yum_grouplist()
 _yum_plugins()
 {
     local val
-    [ $1 = 1 ] && val='\(1\|yes\|true\|on\)' || val='\(0\|no\|false\|off\)'
+    [[ $1 -eq 1 ]] && val='\(1\|yes\|true\|on\)' || val='\(0\|no\|false\|off\)'
     COMPREPLY+=( $( compgen -W '$( command grep -il "^\s*enabled\s*=\s*$val" \
         /etc/yum/pluginconf.d/*.conf 2>/dev/null \
         | sed -ne "s|^.*/\([^/]\{1,\}\)\.conf$|\1|p" )' -- "$2" ) )
@@ -66,6 +40,7 @@ _yum_plugins()
 #   1 = current word to be completed
 _yum_binrpmfiles()
 {
+    local IFS=$'\n'
     COMPREPLY+=( $( compgen -f -o plusdirs -X '!*.rpm' -- "$1" ) )
     COMPREPLY=( $( compgen -W '"${COMPREPLY[@]}"' -X '*.src.rpm' ) )
     COMPREPLY=( $( compgen -W '"${COMPREPLY[@]}"' -X '*.nosrc.rpm' ) )
@@ -75,9 +50,10 @@ _yum_baseopts()
 {
     local opts='--help --tolerant --cacheonly --config --randomwait
         --debuglevel --showduplicates --errorlevel --rpmverbosity --quiet
-        --verbose --assumeyes --version --installroot --enablerepo
+        --verbose --assumeyes --assumeno --version --installroot --enablerepo
         --disablerepo --exclude --disableexcludes --obsoletes --noplugins
-        --nogpgcheck --skip-broken --color --releasever --setopt'
+        --nogpgcheck --skip-broken --color --releasever --setopt --downloadonly
+        --downloaddir --disableincludes'
     [[ $COMP_LINE == *--noplugins* ]] || \
         opts+=" --disableplugin --enableplugin"
     printf %s "$opts"
@@ -89,6 +65,16 @@ _yum_transactions()
         sed -ne 's/^[[:space:]]*\([0-9]\{1,\}\).*/\1/p' )" -- "$cur" ) )
 }
 
+_yum_atgroups()
+{
+    if [[ $1 == \@* ]]; then
+        _yum_helper groups list all "${1:1}"
+        COMPREPLY=( "${COMPREPLY[@]/#/@}" )
+        return 0
+    fi
+    return 1
+}
+
 # arguments:
 #   1 = current word to be completed
 #   2 = previous word
@@ -109,28 +95,32 @@ _yum_complete_baseopts()
             ;;
 
         -c|--config)
+            local IFS=$'\n'
             COMPREPLY=( $( compgen -f -o plusdirs -X "!*.conf" -- "$1" ) )
             return 0
             ;;
 
         --installroot|--downloaddir)
+            local IFS=$'\n'
             COMPREPLY=( $( compgen -d -- "$1" ) )
             return 0
             ;;
 
         --enablerepo)
-            _yum_repolist disabled "$1"
+            _yum_helper repolist disabled "$1"
             return 0
             ;;
 
         --disablerepo)
-            _yum_repolist enabled "$1"
+            _yum_helper repolist enabled "$1"
             return 0
             ;;
 
-        --disableexcludes)
-            _yum_repolist all "$1"
-            COMPREPLY=( $( compgen -W '${COMPREPLY[@]} all main' -- "$1" ) )
+        --disableexcludes|--disableincludes)
+            _yum_helper repolist all "$1"
+            local main=
+            [[ $2 == *excludes ]] && main=main
+            COMPREPLY=( $( compgen -W '${COMPREPLY[@]} all $main' -- "$1" ) )
             return 0
             ;;
 
@@ -182,9 +172,9 @@ _yum()
         _get_comp_words_by_ref -n = cur prev words
 
     # Commands offered as completions
-    local cmds=( check check-update clean deplist distro-sync downgrade
-        groupinfo groupinstall grouplist groupremove help history info install
-        list makecache provides reinstall remove repolist resolvedep search
+    local cmds=( autoremove check check-update clean deplist distro-sync
+        downgrade erase fs groups help history info install list
+        load-transaction makecache provides reinstall remove repolist search
         shell update upgrade version )
 
     local i c cmd subcmd
@@ -192,91 +182,141 @@ _yum()
         [[ -n $cmd ]] && subcmd=${words[i]} && break
         # Recognize additional commands and aliases
         for c in ${cmds[@]} check-rpmdb distribution-synchronization erase \
-            groupupdate grouperase localinstall localupdate whatprovides ; do
+            group groupinfo groupinstall grouplist groupremove groupupdate \
+            grouperase install-na load-ts localinstall localupdate whatprovides ; do
             [[ ${words[i]} == $c ]] && cmd=$c && break
         done
     done
 
     case $cmd in
 
+        autoremove|erase|remove)
+            _yum_atgroups "$cur" || _yum_list installed "$cur"
+            return 0
+            ;;
+
         check|check-rpmdb)
             COMPREPLY=( $( compgen -W 'dependencies duplicates all' \
                 -- "$cur" ) )
             return 0
             ;;
 
-        check-update|grouplist|makecache|provides|whatprovides|resolvedep|\
-        search)
+        check-update|makecache|resolvedep)
             return 0
             ;;
 
         clean)
-            [ "$prev" = "$cmd" ] && \
+            [[ $prev == $cmd ]] && \
                 COMPREPLY=( $( compgen -W 'expire-cache packages headers
                     metadata cache dbcache all' -- "$cur" ) )
             return 0
             ;;
 
         deplist)
+            local IFS=$'\n'
             COMPREPLY=( $( compgen -f -o plusdirs -X '!*.[rs]pm' -- "$cur" ) )
             _yum_list all "$cur"
             return 0
             ;;
 
         distro-sync|distribution-synchronization)
-            [ "$prev" = "$cmd" ] && \
+            [[ $prev == $cmd ]] && \
                 COMPREPLY=( $( compgen -W 'full different' -- "$cur" ) )
             _yum_list installed "$cur"
             return 0
             ;;
 
         downgrade|reinstall)
-            _yum_binrpmfiles "$cur"
-            _yum_list installed "$cur"
+            if ! _yum_atgroups "$cur" ; then
+                _yum_binrpmfiles "$cur"
+                _yum_list installed "$cur"
+            fi
             return 0
             ;;
 
-        erase|remove)
-            _yum_list installed "$cur"
+        fs)
+            if [[ $prev == $cmd ]] ; then
+                COMPREPLY=( $( compgen -W 'filters filter refilter
+                    refilter-cleanup du status diff' -- "$cur" ) )
+                return 0
+            fi
+            case $subcmd in
+                filter)
+                    COMPREPLY=( $( compgen -W 'languages documentation' \
+                        -- "$cur" ) )
+                    return 0
+                    ;;
+                refilter|refilter-cleanup)
+                    _yum_list installed "$cur"
+                    return 0
+                    ;;
+                du|status|diff)
+                    local IFS=$'\n'
+                    COMPREPLY=( $( compgen -f -o plusdirs -- "$cur" ) )
+                    return 0
+                    ;;
+            esac
             return 0
             ;;
 
         group*)
-            _yum_grouplist "" "$cur"
+            if [[ ($cmd == groups || $cmd == group) && $prev == $cmd ]] ; then
+                COMPREPLY=( $( compgen -W 'info install list remove summary' \
+                    -- "$cur" ) )
+            else
+                _yum_helper groups list all "$cur"
+            fi
             return 0
             ;;
 
         help)
-            [ "$prev" = "$cmd" ] && \
+            [[ $prev == $cmd ]] && \
                 COMPREPLY=( $( compgen -W '${cmds[@]}' -- "$cur" ) )
             return 0
             ;;
 
         history)
             if [[ $prev == $cmd ]] ; then
-                COMPREPLY=( $( compgen -W 'info list summary undo redo new
-                    addon-info package-list rollback' -- "$cur" ) )
+                COMPREPLY=( $( compgen -W 'info list packages-list
+                    packages-info summary addon-info redo undo rollback new
+                    sync stats' -- "$cur" ) )
                 return 0
             fi
             case $subcmd in
-                undo|redo|repeat|addon|addon-info|rollback)
-                    _yum_transactions
-                    COMPREPLY=( $( compgen -W "${COMPREPLY[@]} last" \
-                        -- "$cur" ) )
+                undo|repeat|addon|addon-info|rollback)
+                    if [[ $prev == $subcmd ]]; then
+                        COMPREPLY=( $( compgen -W "last" -- "$cur" ) )
+                        _yum_transactions
+                    fi
+                    ;;
+                redo)
+                    case $prev in
+                        redo)
+                            COMPREPLY=( $( compgen -W "force-reinstall
+                                force-remove last" -- "$cur" ) )
+                            _yum_transactions
+                            ;;
+                        reinstall|force-reinstall|remove|force-remove)
+                            COMPREPLY=( $( compgen -W "last" -- "$cur" ) )
+                            _yum_transactions
+                            ;;
+                    esac
                     ;;
                 package-list|pkg|pkgs|pkg-list|pkgs-list|package|packages|\
-                packages-list)
+                packages-list|pkg-info|pkgs-info|package-info|packages-info)
                     _yum_list available "$cur"
                     ;;
                 info|list|summary)
-                    _yum_transactions
                     if [[ $subcmd != info ]] ; then
-                        COMPREPLY=( $( compgen -W "${COMPREPLY[@]} all" \
-                            -- "$cur" ) )
+                        COMPREPLY=( $( compgen -W "all" -- "$cur" ) )
                         [[ $cur != all ]] && _yum_list available "$cur"
                     else
                         _yum_list available "$cur"
                     fi
+                    _yum_transactions
+                    ;;
+                sync|synchronize)
+                    _yum_list installed "$cur"
                     ;;
             esac
             return 0
@@ -288,42 +328,70 @@ _yum()
             ;;
 
         install)
-            _yum_binrpmfiles "$cur"
+            if ! _yum_atgroups "$cur" ; then
+                _yum_binrpmfiles "$cur"
+                _yum_list available "$cur"
+            fi
+            return 0
+            ;;
+
+        install-na)
             _yum_list available "$cur"
             return 0
             ;;
 
         list)
-            [ "$prev" = "$cmd" ] && \
+            [[ $prev == $cmd ]] && \
                 COMPREPLY=( $( compgen -W 'all available updates installed
                     extras obsoletes recent' -- "$cur" ) )
             return 0
             ;;
 
+        load-transaction|load-ts)
+            local IFS=$'\n'
+            COMPREPLY=( $( compgen -f -o plusdirs -X '!*.yumtx' -- "$cur" ) )
+            return 0
+            ;;
+
         localinstall|localupdate)
             _yum_binrpmfiles "$cur"
             return 0
             ;;
 
+        provides|whatprovides)
+            local IFS=$'\n'
+            COMPREPLY=( $( compgen -f -o plusdirs -- "$cur" ) )
+            return 0
+            ;;
+
         repolist)
-            [ "$prev" = "$cmd" ] && \
+            [[ $prev == $cmd ]] && \
                 COMPREPLY=( $( compgen -W 'all enabled disabled' -- "$cur" ) )
             return 0
             ;;
 
+        search)
+            [[ $prev == $cmd ]] && COMPREPLY=( $( compgen -W 'all' -- "$cur" ) )
+            return 0
+            ;;
+
         shell)
-            [ "$prev" = "$cmd" ] && \
+            if [[ $prev == $cmd ]]; then
+                local IFS=$'\n'
                 COMPREPLY=( $( compgen -f -o plusdirs -- "$cur" ) )
+            fi
             return 0
             ;;
 
         update|upgrade)
-            _yum_binrpmfiles "$cur"
-            _yum_list updates "$cur"
+            if ! _yum_atgroups "$cur" ; then
+                _yum_binrpmfiles "$cur"
+                _yum_list updates "$cur"
+            fi
             return 0
             ;;
         version)
-            [ "$prev" = "$cmd" ] && \
+            [[ $prev == $cmd ]] && \
                 COMPREPLY=( $( compgen -W 'all installed available nogroups
                     grouplist groupinfo' -- "$cur" ) )
             return 0
@@ -337,7 +405,11 @@ _yum()
 
     $split && return 0
 
-    COMPREPLY=( $( compgen -W '$( _yum_baseopts ) ${cmds[@]}' -- "$cur" ) )
+    if [[ $cur == -* ]] ; then
+        COMPREPLY=( $( compgen -W '$( _yum_baseopts )' -- "$cur" ) )
+        return 0
+    fi
+    COMPREPLY=( $( compgen -W '${cmds[@]}' -- "$cur" ) )
 } &&
 complete -F _yum -o filenames yum yummain.py
 
diff --git a/etc/yum.logrotate b/etc/yum.logrotate
index e587f96..e716c01 100644
--- a/etc/yum.logrotate
+++ b/etc/yum.logrotate
@@ -1,7 +1,7 @@
 /var/log/yum.log {
     missingok
     notifempty
-    size 30k
+    maxsize 30k
     yearly
     create 0600 root root
 }
